
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>第17章 中介者模式（Mediator Pattern） / 憋错料</title>

    <meta name="description" content="第17章 中介者模式（Mediator Pattern） 原文 第17章 中介者模式(Mediator Pattern) 中介者模式  概述:   在软件开发中,我们有时会碰上许多对象互相联系互相交互的情况,对象之间存在复杂的引用关系,当需求更改时,对系统进行修改将会非常困难.为了对系统的对象进行解耦,可以引入一个间接层来管理对象之间的关系,这就是中介者模式. 结构图:             借图理解:    使用中介者              示例:   1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 1">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">第17章 中介者模式（Mediator Pattern）</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><P>原文&nbsp;<A href="http://www.diyibk.com/post/98.html" rel="external nofollow noreferrer">第17章<br />
中介者模式（Mediator Pattern）</A></p>
<p><H1>中介者模式</H1></p>
<p><STRONG>&nbsp;概述：</STRONG></p>
<p><STRONG>&nbsp;</STRONG></p>
<p>在软件开发中，我们有时会碰上许多对象互相联系互相交互的情况，对象之间存在复杂的引用关系，当需求更改时，对系统进行修改将会非常困难。为了对系统的对象进行解耦，可以引入一个间接层来管理对象之间的关系，这就是中介者模式。</p>
<p><P><STRONG>结构图：</STRONG></p>
<p><STRONG>&nbsp;</STRONG></p>
<p><STRONG><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmRpeWliay5jb20vemJfdXNlcnMvdXBsb2FkLzIwMTQvMDQvMjAxNDA0MTkxMDEyNDFfNjM1MDMuanBn.jpg"></STRONG></p>
<p><STRONG>&nbsp;</STRONG></p>
<p><STRONG>&nbsp;</STRONG></p>
<p><STRONG>&nbsp; &nbsp; &nbsp; 借图理解：</STRONG></p>
<p><STRONG><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmRpeWliay5jb20vemJfdXNlcnMvdXBsb2FkLy8yMDE0LzA0LzIwMTQwNDE5MTAzMTAyXzE1NTM3LnBuZw==.jpg"></STRONG></p>
<p><STRONG>&nbsp;<br />
&nbsp;使用中介者</STRONG></p>
<p><STRONG>&nbsp; &nbsp;</STRONG></p>
<p><P><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvd3d3LmRpeWliay5jb20vemJfdXNlcnMvdXBsb2FkLzIwMTQvMDQvMjAxNDA0MTkxMDMxMDFfNjY2NzAucG5n.jpg"></p>
<p><P><STRONG>&nbsp;</STRONG></p>
<p><STRONG>&nbsp; &nbsp; &nbsp; &nbsp;示例：</STRONG></p>
<p><STRONG>&nbsp;</STRONG></p>
<p><TABLE><br />
  <TBODY><br />
  <TR><br />
    <TD></p>
<p>1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18</p>
<p>19</p>
<p>20</p>
<p>21</p>
<p>22</p>
<p>23</p>
<p>24</p>
<p>25</p>
<p>26</p>
<p>27</p>
<p>28</p>
<p>29</p>
<p>30</p>
<p>31</p>
<p>32</p>
<p>33</p>
<p>34</p>
<p>35</p>
<p>36</p>
<p>37</p>
<p>38</p>
<p>39</p>
<p>40</p>
<p>41</p>
<p>42</p>
<p>43</p>
<p>44</p>
<p>45</p>
<p>46</p>
<p>47</p>
<p>48</p>
<p>49</p>
<p>50</p>
<p>51</p>
<p>52</p>
<p>53</p>
<p>54</p>
<p>55</p>
<p>56</p>
<p>57</p>
<p>58</p>
<p>59</p>
<p>60</p>
<p>61</p>
<p>62</p>
<p>63</p>
<p>64</p>
<p>65</p>
<p>66</p>
<p>67</p>
<p>68<br /></TD><br />
    <TD></p>
<p><CODE>&nbsp;&nbsp;</CODE><CODE>///&nbsp;&lt;summary&gt;</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>///&nbsp;抽象中介者</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>///&nbsp;&lt;/summary&gt;</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>public</CODE>&nbsp;<CODE>abstract</CODE>&nbsp;<CODE>class</CODE>&nbsp;<CODE>Mediator</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>{</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>public</CODE>&nbsp;<CODE>Colleague&nbsp;_colleague;</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>public</CODE>&nbsp;<CODE>Colleague&nbsp;GetColleague()</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>{</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>return</CODE>&nbsp;<CODE>_colleague;</CODE></p>

<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>}</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>public</CODE>&nbsp;<CODE>void</CODE>&nbsp;<CODE>SetColleague(Colleague&nbsp;colleague)</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>{</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>_colleague&nbsp;=&nbsp;colleague;</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>}</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>public</CODE>&nbsp;<CODE>abstract</CODE>&nbsp;<CODE>void</CODE>&nbsp;<CODE>DoSomething();</CODE></p>

<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>}</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>///&nbsp;&lt;summary&gt;</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>///&nbsp;具体的中介者</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>///&nbsp;&lt;/summary&gt;</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>public</CODE>&nbsp;<CODE>class</CODE>&nbsp;<CODE>ConcreteMediator&nbsp;:&nbsp;Mediator</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>{&nbsp;</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>public</CODE>&nbsp;<CODE>override</CODE>&nbsp;<CODE>void</CODE>&nbsp;<CODE>DoSomething()</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>{</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>//调用Colleague对象的方法</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>_colleague.Method();</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>}</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>}</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>///&nbsp;&lt;summary&gt;</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>///&nbsp;抽象Colleague</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>///&nbsp;&lt;/summary&gt;</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>public</CODE>&nbsp;<CODE>abstract</CODE>&nbsp;<CODE>class</CODE>&nbsp;<CODE>Colleague</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>{</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>public</CODE>&nbsp;<CODE>abstract</CODE>&nbsp;<CODE>void</CODE>&nbsp;<CODE>Method();</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>}</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>///&nbsp;&lt;summary&gt;</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>///&nbsp;具体的Colleague</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>///&nbsp;&lt;/summary&gt;</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>public</CODE>&nbsp;<CODE>class</CODE>&nbsp;<CODE>ConcreteColleague1:Colleague</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>{</CODE></p>

<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>private</CODE>&nbsp;<CODE>Mediator&nbsp;mediator;</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>public</CODE>&nbsp;<CODE>ConcreteColleague1(Mediator&nbsp;mediator)</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>{</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>this</CODE><CODE>.mediator&nbsp;=&nbsp;mediator;</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>}</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>public</CODE>&nbsp;<CODE>override</CODE>&nbsp;<CODE>void</CODE>&nbsp;<CODE>Method()</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>{</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>Console.WriteLine(</CODE><CODE>"ConcreteColleague1要做的事！"</CODE><CODE>);</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>}</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>}</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>///&nbsp;&lt;summary&gt;</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>///&nbsp;具体的Colleague</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>///&nbsp;&lt;/summary&gt;</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>public</CODE>&nbsp;<CODE>class</CODE>&nbsp;<CODE>ConcreteColleague2&nbsp;:&nbsp;Colleague</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>{</CODE></p>

<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>private</CODE>&nbsp;<CODE>Mediator&nbsp;mediator;</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>public</CODE>&nbsp;<CODE>ConcreteColleague2(Mediator&nbsp;mediator)</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>{</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>this</CODE><CODE>.mediator&nbsp;=&nbsp;mediator;</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>}</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>public</CODE>&nbsp;<CODE>override</CODE>&nbsp;<CODE>void</CODE>&nbsp;<CODE>Method()</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>{</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>Console.WriteLine(</CODE><CODE>"ConcreteColleague2要做的事！"</CODE><CODE>);</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>}</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>}</CODE></p>
<p></TD></TR></TBODY></TABLE></p>
<p>客户端调用</p>
<p><TABLE><br />
  <TBODY><br />
  <TR><br />
    <TD></p>
<p>1</p>
<p>2</p>
<p>3</p>
<p>4</p>
<p>5</p>
<p>6</p>
<p>7</p>
<p>8</p>
<p>9</p>
<p>10</p>
<p>11</p>
<p>12</p>
<p>13</p>
<p>14</p>
<p>15</p>
<p>16</p>
<p>17</p>
<p>18<br /></TD><br />
    <TD></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>class</CODE>&nbsp;<CODE>Program</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>{</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>static</CODE>&nbsp;<CODE>void</CODE>&nbsp;<CODE>Main(</CODE><CODE>string</CODE><CODE>[]&nbsp;args)</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>{</CODE></p>

<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>Mediator&nbsp;mediator&nbsp;=&nbsp;</CODE><CODE>new</CODE>&nbsp;<CODE>ConcreteMediator();</CODE></p>

<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>Colleague&nbsp;coll1&nbsp;=&nbsp;</CODE><CODE>new</CODE>&nbsp;<CODE>ConcreteColleague1(mediator);</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>mediator.SetColleague(coll1);</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>coll1.Method();</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>Console.ReadLine();</CODE></p>

<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>Colleague&nbsp;coll2&nbsp;=&nbsp;</CODE><CODE>new</CODE>&nbsp;<CODE>ConcreteColleague2(mediator);</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>mediator.SetColleague(coll2);</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>coll2.Method();</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>Console.ReadLine();</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>}</CODE></p>
<p><CODE>&nbsp;&nbsp;&nbsp;&nbsp;</CODE><CODE>}</CODE></p>
<p></TD></TR></TBODY></TABLE></p>
<p><P><STRONG>效果：</STRONG></p>
<p><STRONG>&nbsp; &nbsp;&nbsp;</STRONG></p>
<p>1.降低了系统对象之间的耦合性，使得对象易于独立的被复用。</p>
<p>2.提高系统的灵活性，使得系统易于扩展和维护。</p>
<p><P><STRONG>适用场景：</STRONG></p>
<p><STRONG>&nbsp; &nbsp; &nbsp;</STRONG></p>
<p>1.一组对象以定义良好但是复杂的方式进行通信。产生的相互依赖关系结构混乱且难以理解。</p>
<p>2.一个对象引用其他很多对象并且直接与这些对象通信,导致难以复用该对象。</p>
<p>3.想定制一个分布在多个类中的行为，而又不想生成太多的子类。</p>
<p><P><STRONG><A href="http://www.diyibk.com/post/39.html" rel="external nofollow noreferrer">设计模式系列文章入口</A>:<A href="http://www.diyibk.com/post/39.html" rel="external nofollow noreferrer">http://www.diyibk.com/post/39.html</A></STRONG></p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-03-29 16:31:58 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong> <a href="https://www.biecuoliao.com/tag/color/" title="color">color</a>, <a href="https://www.biecuoliao.com/tag/style/" title="style">style</a>, <a href="https://www.biecuoliao.com/tag/code/" title="code">code</a>, <a href="https://www.biecuoliao.com/tag/class/" title="class">class</a>, <a href="https://www.biecuoliao.com/tag/tar/" title="tar">tar</a>        </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>第17章 中介者模式（Mediator Pattern）的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDBwwk3.html" rel="bookmark">二十三种设计模式&lbrack;17&rsqb; - 中介者模式&lpar;Mediator Pattern&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				前言 在开发软件的过程中,我们通常会将类设计的比较单纯,使其复用性更高.但类间的相互引用又使得类本身在没有其他类的支持下不能正常工作,导致其复用性降低.所以为了提高类的复用性我们需要尽可能的减少对其它类的引用,也就是说我们常说的解耦.中介者模式,顾名思义,就是存在一个类似中介的角色,类与类之间不直接交互而是通过中介进行间接的交互,也就意味着类与类之间不需要存在显示的引用,以达到松耦合的目的. 中介者模式,对象行为型模式的一种.在&lt;设计模式 - 可复用的面向对象软件&gt;一书中将之描述为&quot;			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0k1EZ74.html" rel="bookmark">设计模式&lpar;行为型&rpar;之中介者模式&lpar;Mediator Pattern&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PS一句:最终还是选择CSDN来整理发表这几年的知识点,该文章平行迁移到CSDN.因为CSDN也支持MarkDown语法了,牛逼啊! [工匠若水 http://blog.csdn.net/yanbober] 阅读前一篇&lt;设计模式(行为型)之职责链模式(Chain of Responsibility Pattern)&gt;http://blog.csdn.net/yanbober/article/details/45531395 概述 如果对象之间的联系呈现为网状结构,存在大量的多对多联系,在网状结			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0npQjv4.html" rel="bookmark">&lbrack;设计模式&rsqb; 中介者模式 Mediator Pattern</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				在GOF的&lt;设计模式:可复用面向对象软件的基础&gt;一书中对中介者模式是这样说的:用一个中介对象来封装一系列的对象交互.中介者使各对象不需要显式地相互引用,从而使其耦合松散,而且可以独立地改变它们之间的交互. 我们都知道,面向对象设计鼓励将行为分布到各个对象中.但是,这种分布可能会导致对象间有许多连接.在最坏的情况下,每一个对象都知道其他所有对象,就造成了复杂的关联关系.虽然将一个系统分割成许多对象通常可以增强可复用性,但是对象间相互连接的激增又会降低其可复用性.大量的相互连接使得一个对象似乎不太			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEwRKP3.html" rel="bookmark">18&period;中介者模式&lpar;Mediator Pattern&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				using System; namespace ConsoleApplication9 { class Program { /// &lt;summary&gt; /// 中介者模式,定义了一个中介对象来封装一系列对象之间的交互关系. /// 中介者使各个对象之间不需要显式地相互引用,从而使耦合性降低,而且可以独立地改变它们之间的交互行为. /// &lt;/summary&gt; /// &lt;param name=&quot;args&quot;&gt;&lt;/param&gt; static v			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/v0kL5X3.html" rel="bookmark">23种设计模式--中介者模式-Mediator Pattern</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				一.中介者模式的介绍     中介者模式第一下想到的就是中介,房子中介,婚姻中介啊等等,当然笔者也希望来个婚姻中介给我介绍一个哈哈哈,,回归正题中介者模式分成中介者类和用户类,根据接口编程的方式我们再把中介和用户类分成2个类,这样就成了抽象中介者角色,具体中介者角色.抽象同事类和具体同事类.来几个例子比如说各种游戏平台,还有我们最熟悉的QQ平台,等等这些都是中介者模式的具体应用,中介者模式常用于处理通信之间复杂有关联的业务,这样就会存在一个缺点比如说因为中介者处理了好多用户之间的关系,一但发生错			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/49L5Pb3.html" rel="bookmark">&lbrack;设计模式&rsqb;&amp;lt&semi;8&amp;gt&semi;&period; C&plus;&plus;与中介者模式&lpar;mediator pattern&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				意图:用一个中介者对象封装一系列的对象交互.中介者使各对象不需要显式的相互引用,从而减小耦合. 原文:默默的EEer 地址:http://www.cnblogs.com/hebaichuanyeah/p/6091506.html 实际就是指,利用一个中介者对象来连接两个对象的操作.例如需求是,A对象更新/改变了,B对象也跟着相应的更新/改变,不通过直接调用B对象 一个例子,详见注释 #include &lt;iostream&gt; using namespace std; class Colleague			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0xrBqn4.html" rel="bookmark">&lpar;17&rpar;：&lpar;行为型模式&rpar; Mediator 中介者模式</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				(17):(行为型模式) Mediator 中介者模式,布布扣,bubuko.com			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0a5oAk0.html" rel="bookmark">第 17 章 责任链模式【Chain of Responsibility Pattern】</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				以下内容出自:&lt;&lt;24种设计模式介绍与6大设计原则&gt;&gt; 中国古代对妇女制定了“三从四德”的道德规范,“三从”是指“未嫁从父.既嫁从夫.夫死从子”,也就是说一个女性,在没有结婚的时候要听从于父亲,结了婚后听从于丈夫,丈夫死了还要听儿子的,举个例子来说,一个女的要出去逛街,同样这样的一个请求,在她没有出嫁前她必须征得父亲的同意,出嫁之后必须获得丈夫的许可,那丈夫死了怎么办?一般都是男的比女的死的早,还要问问儿子是否允许自己出去逛街,估计你下边马上要问要是没有儿子怎么办?请示小叔子.侄子			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/0YpzOaM.html" rel="bookmark">设计模式之第19章-中介者模式&lpar;Java实现&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				设计模式之第19章-中介者模式(Java实现) “测试妹纸找你,你的代码出问题了.”“美工妹纸让你看看界面怎么样.”身为程序员总要和各种人打交道,但是如果再分为前端.后端工程师的话,那么关系就会错综复杂起来了,这个时候如果有中介者进行中转,类似于星型网络拓扑的交换机,那么该有多好.(PS:注孤生啊,和测试妹纸.美工妹纸什么的一起讨论增进感情多好,那么好的机会都不珍惜.编者按:我是要做那个中介者,懂么?中介者!众人:good job!)“鱼哥,叫我干嘛?”真是说曹操曹操到,刚刚正说你来着,行了,你			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/BMzk9k0.html" rel="bookmark" class="title">web基础知识（一）关于ajax传值最基础东西</a>
					<div>
						HTTP方法之 GET对比POST GET:从指定的资源请求数据, POST:向指定的资源提交要被处理的数据 GET方法: 请注意,查询字符串(名称/值对)是在 GET 请求的 URL 中发送的: / ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/x0dEJ63.html" rel="bookmark" class="title">如何在Angular2-cli中使用插件&lpar;不使用配置&rpar;</a>
					<div>
						重要点: 要把插件放在src/assets文件中 如何在angular-cli中使用jquery插件 a.在index.html中引入 &lt;script  src=&quot;./assets/j ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/9MEDkQ4.html" rel="bookmark" class="title">电脑管家保障亿万网民的网络安全</a>
					<div>
						如今网络性能监控工具对于it行业的来说是必不可少的一个工具,但是在使用的同时也要注意考虑到网络性能监控工具应该具备哪些技能. 国际权威评测机构AV-Comparatives(简称AV-C)发布2016 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3r5ZpX0.html" rel="bookmark" class="title">ajax入门详解</a>
					<div>
						l 一个实例 在开始正式讲解 Ajax之前,首先让我们先来看看Google Map使用Ajax改善其产品设计的效果. 1． 在浏览器地址栏中输入http://maps.google.com打开Goog ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6871d3.html" rel="bookmark" class="title">sqoop job local 和 Cannot initialize Cluster 问题</a>
					<div>
						hadoop版本:Hadoop 2.3.0-cdh5.0.0 sqoop版本:Sqoop 1.4.4-cdh5.0.0 配置好sqooop-env.xml: #Set path to where bi ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0lX2jW0.html" rel="bookmark" class="title">二五眼十大生活谣个言</a>
					<div>
						﻿﻿ http://www.ebay.com/cln/nd9ixemnu/-/170299039017/20150202html http://www.ebay.com/cln/emkxc5513_l ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/47pkYxM.html" rel="bookmark" class="title">Word 2003中对不同的节设置不同的页面边框的特殊情况小结</a>
					<div>
						除了使用普通思路给不同节(或者节中的首页,或者其他中其他页)可以设置不同的页面边框外,在实现这个操作的过程中还有一些特殊情况值得注意.在此作小结如下: 对于两个连续类型分节符围起来的节,且此节是一个页 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEkqmy3.html" rel="bookmark" class="title">Web程序的运行原理及流程（一）</a>
					<div>
						自己做Web程序的开发也有两年多了 从最开始跟风学框架  到第一用上框架的欣喜若狂 我相信每个程序员都是这样过来的 在大学学习一门语言 学会后往往很想做一个实际的项目出来  我当时第一次做WEB项目看 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/M6bGDyM.html" rel="bookmark" class="title">JavaScript面向对象之Windows对象</a>
					<div>
						JavaScript之Window对象 首先我们先了解一个概念:事件. 事件,就是把一段代码设置好,满足条件时触发.或者说,事件是可以被 JavaScript 侦测到的行为. 网页中每个元素都可以触发 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0nkxxN3.html" rel="bookmark" class="title">对于虚拟机三种网卡模式桥接、NAT、Host only的理解</a>
					<div>
						对于刚接触虚拟机的朋友,可能一开始对于虚拟机网卡的模式有点找不着规律,我自己从使用中总结出一些经验吧,画几张图来表示.有不对的地方请帮忙指正. 一. 桥接模式就像把电脑网卡当作交换机,虚拟机和win7 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPWKwv4.html" rel="bookmark" class="title">python3随记&mdash;&mdash;字符编码</a>
					<div>
						1.1什么是字节 字节(Byte)是计算机信息技术用于计量存储容量的一种计量单位,也表示一些计算机编程语言中的数据类型和语言字符. 比特(bit)在计算机中最小的单位,在二进制位的电脑的系统中,每一b ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/49WxZb0.html" rel="bookmark" class="title">塘盅内短扑至再虑俪扑姓韧职鲜敲</a>
					<div>
						http://www.ebay.com/cln/jjpbldtft-djrtrvznv/2014-11-29/137857313014 http://www.ebay.com/cln/txxzrxxp ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/35wel1M.html" rel="bookmark" class="title">判断链表是否带环，若带环，找到环的入口点</a>
					<div>
						#pragma once #include&lt;iostream&gt; using namespace std; template&lt;class T&gt; struct LinkNode { ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MyQXDEM.html" rel="bookmark" class="title">zip文件压缩（转）</a>
					<div>
						zip文件结构 上面中的每一行都是一个条目,zip文件就是由一个或者多个条目组成. 条目在Java中对应ZipEntry类 创建zip压缩文件 知道了zip文件结构之后,大概就知道怎么去创建一个zip ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MEWDRD3.html" rel="bookmark" class="title">使用eclipse上传代码到SVN服务器-----学习总结&lpar;一&rpar;</a>
					<div>
						一.下载svn服务端. 安装后的界面 二.创建svn用户 右键点击Users,创建用户 三.上传代码的路径 右键获取上传代码的路径					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0dzjn64.html" rel="bookmark" class="title">apache 基本vhost配置</a>
					<div>
						经常使用Apache虚拟主机进行开发和测试,但每次需要配置虚拟主机时都习惯性的ctrl+c和ctrl+v,这次由于重装系统,需要配置一个新的PHP开发环境虚拟主机,于是总结一下Apaceh配置http ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4pNB6o0.html" rel="bookmark" class="title">Mac 开发快速查阅目录</a>
					<div>
						以下内容转自 &lt;Leopard轻松编程:帮你节省代码&gt; 目录: - Core Animation 核心动画 - 视图描绘 - 和快速查看协同工作 - 管理多视图(针对自定义的分页控件等)  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MgYeOn3.html" rel="bookmark" class="title">C&num; 索引器，实现IEnumerable接口的GetEnumerator&lpar;&rpar;方法</a>
					<div>
						当自定义类需要实现索引时,可以在类中实现索引器. 用Table作为例子,Table由多个Row组成,Row由多个Cell组成, 我们需要实现自定义的table[0],row[0] 索引器定义格式为 [ ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3vAxrZ0.html" rel="bookmark" class="title">学习28</a>
					<div>
						7月2日,新闻,小儿推拿培训. 出去. 赵论军和孟佳佳在他们其儿推有些尴尬,他唱培训比你好多济南. ,重要培训推拿,那么我想请问苏山,许佳佳痛快多小钱答应济南. 这可都推拿钱啊,按推拿,他最大培训感受 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXDxKQM.html" rel="bookmark" class="title">马云&mdash;环球转型论坛压轴演讲全文</a>
					<div>
						大家下午好.可否再把灯光调亮一些?我想看到大家的脸.我会害怕对着黑乎乎的一片说话.这次的行程有很多很棒的对话,我感触很深,让我想起了很多在我身上发生的事情. 一:乐观.坚持.不抱怨,才有机会 首先,我 ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 11 q. 0.026 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
